/* f.h */


/*------------------------------------------------------------------------*/
#ifdef  ANSI
#define PROTO(prototype) prototype
#else
#define PROTO(prototype) ()
#define void char
#undef NULL
#define NULL 0
#endif
/*------------------------------------------------------------------------*/

#define modulo(v) (float)(sqrt((((v)->x) * ((v)->x)) + (((v)->y) * ((v)->y)) + (((v)->z) * ((v)->z))))
#define produto_escalar(u,v) (float)((float)(((u)->x) * ((v)->x)) + (float)(((u)->y) * ((v)->y)) + (float)(((u)->z) * ((v)->z)))
#define angulouv(u,v) (acos ((float)(produto_escalar (u, v) / (modulo(u) * modulo(v))) ) )
#define ortogonal(u,v) (!produto_escalar (u, v))
#define ALOCA(n,x)  ((x *)aloca (n * sizeof(x)))
#define ABS(x)      ((x < 0)?(-x):(x))

typedef struct ponto2d {
  float x, y;
} ponto2d;

typedef struct ponto3d {
  float x, y, z;
} ponto3d;

typedef float matriz3x3[3][3];

typedef float matriz4x4[4][4];

/* prototipos das funcoes */

void *aloca PROTO ((unsigned long int));

void adicao PROTO ((ponto3d *, ponto3d *, ponto3d *));

void subtracao PROTO ((ponto3d *, ponto3d *, ponto3d *));

void realXvetor PROTO ((float, ponto3d *, ponto3d *));

void normalizacao PROTO ((ponto3d *, ponto3d *));

float distancia PROTO ((ponto3d *, ponto3d *));

void projecao_uv PROTO ((ponto3d *, ponto3d *, ponto3d *));

void produto_vetorial PROTO ((ponto3d *, ponto3d *, ponto3d *));

void vetorXmatriz PROTO ((ponto3d *, matriz3x3, ponto3d *));

void vetorXmatriz4x4 PROTO ((ponto3d *, matriz4x4, ponto3d *));

void adicao3x3 PROTO ((matriz3x3, matriz3x3, matriz3x3));

void subtracao3x3 PROTO ((matriz3x3, matriz3x3, matriz3x3));

void multiplicacao3x3 PROTO ((matriz3x3, matriz3x3, matriz3x3));

void transposta3x3 PROTO ((matriz3x3, matriz3x3));

void adicao4x4 PROTO ((matriz4x4, matriz4x4, matriz4x4));

void subtracao4x4 PROTO ((matriz4x4, matriz4x4, matriz4x4));

void multiplicacao4x4 PROTO ((matriz4x4, matriz4x4, matriz4x4));

