/* camera.h */


/*-----------------------------------------------------------------------*/
#ifdef  ANSI
#define PROTO(prototype) prototype
#else
#define PROTO(prototype) ()
#define void char
#undef NULL
#define NULL 0
#endif
/*------------------------------------------------------------------------*/

#define PARALELA    1
#define PERSPECTIVA 2

#define FALSE 0
#define TRUE  1 

/* prototipos das funcoes */

/* ponteiro para a funcao de projecao escolhida (paralela ou perspectiva) */
extern void (*projecao) PROTO ((ponto3d *, ponto2d *));
/* 
void posicao PROTO ((ponto3d *));

void alvo PROTO ((ponto3d *));

void direcao PROTO ((ponto3d *));

void vertical PROTO ((ponto3d *));

void foco PROTO ((float));

void abertura PROTO ((float, float));

void tipo_projecao PROTO ((int));

void normal PROTO ((ponto3d *));

void base PROTO ((ponto3d *, ponto3d *, ponto3d *));

void janela PROTO ((float, float, float, float));

void tela PROTO ((int, int, int, int));

void pega_tela PROTO ((int *, int *, int *, int *));

void clipping PROTO ((float));

float distancia_plano PROTO (());

void sobe_desce PROTO ((float));

void direita_esquerda PROTO ((float));

void roda_vertical PROTO ((float));

void roda_horizontal PROTO ((float));

void gira_orientacao PROTO ((float));

void aproxima PROTO ((void));

void afasta PROTO ((void));

void transforma_base PROTO ((matriz3x3));

void calcula_base PROTO ((ponto3d *, ponto3d *));

void monta_base PROTO ((ponto3d *, ponto3d *, ponto3d *));

void muda_base PROTO ((ponto3d *, ponto3d *));

void muda_referencial PROTO ((ponto3d *, ponto3d *));

void projecao_perspectiva PROTO ((ponto3d *, ponto2d *));


void mapeia PROTO ((ponto2d *, ponto2d *));

int escondido PROTO ((ponto3d *, ponto3d *));
*/

void projecao_paralela PROTO ((ponto3d *, ponto2d *));
